; file: vce.inc
; VCE related macros and defines.
;==============================================================================;

; VCE/HuC6260 (physical page $FF, mapped into logical page $00)

VCE_MAIN        = $0400
;---------------;---------------;----------------------------------------------;
VCE_CONTROL     = VCE_MAIN      ; VCE Control Register
VCE_ADDR_LO     = VCE_MAIN+2    ; Color Table Address Register
VCE_ADDR_HI     = VCE_MAIN+3    ; Color Table Address Register
VCE_DATA_LO     = VCE_MAIN+4    ; Color Table Read/Write Register
VCE_DATA_HI     = VCE_MAIN+5    ; Color Table Read/Write Register

;------------------------------------------------------------------------------;
; VCE control:
; 76543210
; ||__||||
; |  | |++- dot clock (see below)
; |  | +--- blur edges of sprites/bg chars
; |  +----- no effect
; +-------- monochrome (0=color; 1=monochrome)

VCE_DOTCLOCK_5MHZ    = %00 ; 00 - 5MHz
VCE_DOTCLOCK_7MHZ    = %01 ; 01 - 7MHz
VCE_DOTCLOCK_10MHZ_B = %10 ; 10 - 10MHz, less artifacts (B = "better")
VCE_DOTCLOCK_10MHZ_W = %11 ; 11 - 10MHz, more artifacts (W = "worse")

VCE_BLUR_ON  = 1<<2
VCE_BLUR_OFF = 0<<2

VCE_MODE_COLOR = $00 ; color mode
VCE_MODE_MONO  = $80 ; monochrome mode

;------------------------------------------------------------------------------;
; VCE palette locations
VCE_BGPAL_START  = $000 ; first 256 colors are BG
VCE_SPRPAL_START = $100 ; second 256 colors are SPR
VCE_PALSET_SIZE  = 16   ; 16 colors per palette set

;==============================================================================;

; todo: vce palette macros
; - vce_palDataRGB

